<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { watch, ref, inject } from 'vue';
import BoxSelector, { type item } from '@/components/general/form/BoxSelector.vue';
import { useMetaStore } from '@/stores/meta';
import { storeToRefs } from 'pinia';
import { paneTypes, itemEnum, userType } from '@/enums/enums';
import { useFreeformStore } from '@/stores/freeform';
import IconButton from '@/components/general/IconButton.vue';
import Modal from '@/components/general/Modal.vue';
import ColorSwatch from '@/components/general/form/ColorSwatch.vue';
import Dropdown from '@/components/general/Dropdown.vue';

import { useI18n } from 'vue-i18n';
import useFreeform from '@/hooks/useFreeform';

const { t } = useI18n();
const $t = t;



const props = defineProps<{
    color: string,
    shape: string,
    postIndex: number,
    post: any
}>();

const emits = defineEmits<{
    (e: 'edit'): void
}>();

const elementColor = ref('');
const elementShape = ref('');

elementColor.value = props.color;
elementShape.value = props.shape;

watch(() => props.color, (color) => {
    elementColor.value = color;
});

watch(() => props.shape, (shape) => {
    elementShape.value = shape;
});

const { deletePost: deletePostHook } = useFreeform();
const meta = useMetaStore();
const { paneType } = storeToRefs(meta);
let store = useFreeformStore();

const { getFullUsable, getDeletable, getMovable, getUserType, getStyle } = storeToRefs(store);
const configuration = inject<any>('configuration');
let elementColors: item[] = [];
if (paneType.value === paneTypes.FREEFORM)
    elementColors = configuration.style.shapeColors;
let shapes: item[] = configuration.style.shapes;

const changeColor = (close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, color: elementColor.value });
}

const changeShape = (close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, shape: elementShape.value });
}

const changeVisibility = (value: boolean, close: () => void) => {
    close();
    store.editPostProps({ postIndex: props.postIndex, visible: value });
}

const editPost = (close: () => void) => {
    close();
    emits('edit');
}

const copyPost = (close: () => void) => {
    close();
    store.createPost({ title: props.post.title.headline, text: props.post.title.post, body: props.post.body, info: props.post.info });
    showDeleteModal(false);
}

const deletePost = () => {
    deletePostHook({ postIndex: props.postIndex });
    showDeleteModal(false);
}

const movePostZAxis = (direction: string, close: () => void) => {
    close();
    store.editPostZAxis({ postIndex: props.postIndex, direction: direction });
}

const isDeleteModalOpen = ref(false);
const showDeleteModal = (value: boolean) => {
    isDeleteModalOpen.value = value;
}

const openDeleteModal = (close: () => void) => {
    close();
    setTimeout(() => {
        showDeleteModal(true);
    })
}

const moreButtonDropdownRef = ref();

</script> 
<template>
    <Dropdown>
        <template #button>
            <Tooltip :tooltip="$t('tooltips.settings')">
                <button class="hover:bg-gray-100 px-1 rounded-md text-lg" :id="'more_post_' + post.id">
                    <strong><i class="ri-more-line"></i></strong>
                </button>
            </Tooltip>
        </template>
        <template v-slot="{ close }">
            <div class="flex flex-col gap-2">
                <div class="flex flex-col gap-1">
                    <BoxSelector v-model="elementColor" :items="elementColors" :identifier="itemEnum.VALUE"
                        type="colors" @click="changeColor(close)" />
                    <ColorSwatch v-model="elementColor" :onChange="() => changeColor(close)" />
                </div>
                <div class="border border-gray-200"></div>
                <div>
                    <BoxSelector v-model="elementShape" :items="shapes" :identifier="itemEnum.ID" type="shapes"
                        @click="changeShape(close)" />
                </div>
                <div class="border border-gray-200" v-if="getFullUsable || getDeletable"></div>
                <div>
                    <label v-if="getFullUsable || getDeletable">{{ $t('contentPage.editLabel') }}</label>
                    <div class="flex flex-row">
                        <div class="w-full">
                            <IconButton icon="pencil" :tooltip="$t('contentPage.editLabel')" @click="editPost(close)"
                                v-if="getFullUsable" color="text-blue-700" />
                        </div>
                        <div class="w-full">
                            <IconButton icon="file-copy" :tooltip="$t('contentPage.copyLabel')" @click="copyPost(close)"
                                v-if="getFullUsable && post && ((post.body && post.body.type !== 'file') || !post.body)"
                                color="text-cyan-500" />
                        </div>
                        <div class="w-full">
                            <IconButton icon="delete-bin" :tooltip="$t('contentPage.deleteLabel')"
                                @click="openDeleteModal(close)" v-if="getDeletable" color="text-red-700" />
                        </div>
                    </div>
                </div>
                <div class="border border-gray-200" v-if="getMovable"></div>
                <label v-if="getMovable">{{ $t('contentPage.moveLabel') }}</label>
                <div class="flex flex-row" v-if="getMovable">
                    <div class="w-full">
                        <IconButton icon="arrow-up" :tooltip="$t('contentPage.move.front')"
                            @click="movePostZAxis('front', close)" color="text-yellow-600"
                            v-if="paneType === paneTypes.FREEFORM && getMovable" />
                    </div>
                    <div class="w-full">
                        <IconButton icon="arrow-down" :tooltip="$t('contentPage.move.back')"
                            @click="movePostZAxis('back', close)" color="text-orange-600"
                            v-if="paneType === paneTypes.FREEFORM && getMovable" />
                    </div>
                </div>
                <div class="border border-gray-200"
                    v-if="getUserType === userType.ADMIN || getUserType === userType.MODERATOR"></div>
                <div v-if="getUserType === userType.ADMIN || getUserType === userType.MODERATOR">
                    <label>{{ $t('contentPage.hideLabel') }}</label>
                    <div class="flex flex-row">
                        <div class="w-full">
                            <IconButton icon="eye" :tooltip="$t('tooltips.hide')"
                                @click="changeVisibility(false, close)" v-if="props.post.visible"
                                color="text-sky-500" />
                        </div>
                        <div class="w-full">
                            <IconButton icon="eye-off" :tooltip="$t('tooltips.unhide')"
                                @click="changeVisibility(true, close)" v-if="!props.post.visible"
                                color="text-teal-500" />
                        </div>
                    </div>
                </div>
            </div>
        </template>
    </Dropdown>
    <Modal :labelSubmit="$t('adminMenu.pageDelete.submit')" :labelCancel="$t('general.buttons.cancel')"
        @submit="deletePost" @cancel="showDeleteModal(false)" :text="$t('contentPage.post.deletePost')"
        :font="getStyle?.font ? getStyle.font : ''" v-if="isDeleteModalOpen"></Modal>
</template>